/**
	$Id $

	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.extensions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;

/**
	Wrapper for HttpServletRequest that allows us to set 
	proper servlet path and path info attributes for an extension
	servlet. The result should be the same as if the servlet had
	been mapped as a "standalone" servlet in web.xml.

	@author nicklas
	@version 2.10
	@base.modified $Date: 2008-12-11 14:27:36 +0100 (Thu, 11 Dec 2008) $
*/
public class RequestWrapper
	extends HttpServletRequestWrapper
{

	private final String pathInfo;
	private final String servletPath;
	
	public RequestWrapper(HttpServletRequest request, String servletPath, String pathInfo)
	{
		super(request);
		this.pathInfo = pathInfo;
		this.servletPath = servletPath;
	}

	/**
		From the HttpServletRequestInterface
		------------------------------------
	*/
	@Override
	public String getPathInfo()
	{
		return pathInfo;
	}
	@Override
	public String getServletPath()
	{
		return servletPath;
	}
	// ------------------------------------

	
}
