/*
	$Id: Registered.java 4696 2008-12-09 13:55:06Z nicklas $

	Copyright (C) 2005 Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

import java.util.Date;

/**
	Items that implements this interface has their registration
	date stored in the database. Note to implementors!!! Do not
	forget that Date is a mutable class and that a copy must be made
	before returning the value to client applications.
	See {@link DateUtil#copy(Date)}
	
	@author Nicklas
	@version 2.10
	@base.modified $Date: 2008-12-09 14:55:06 +0100 (Tue, 09 Dec 2008) $
*/
public interface Registered
	extends Identifiable
{

	/**
		Get the date that the item was registered in the database.
		@return A date or null if this is not known
		@since 2.10
	*/
	public Date getEntryDate();

}
