/*
	$Id: DoubleParameterValueData.java 4517 2008-09-11 20:11:02Z jari $

	Copyright (C) 2005 Samuel Andersson, Johan Enell, Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

import java.util.List;
import java.util.ArrayList;

/**
	Double parameter value.

	@author Nicklas, Samuel
	@version 2.0
	@see <a href="../../../../../../html/developerdoc/api/data_api.parameters.html">Parameters overview</a>
	@hibernate.subclass discriminator-value="4"
	@base.modified $Date: 2005-07-05 15:51:30 +0200 (ti, 05 jul 2005) $
*/
public class DoubleParameterValueData
	extends ParameterValueData<Double>
{
	public DoubleParameterValueData()
	{}
	
	public DoubleParameterValueData(Double... values)
	{
		super(values);
	}

	private List<Double> values;
	/**
		@hibernate.bag table="`DoubleValues`" lazy="true" cascade="all"
		@hibernate.collection-key column="`id`"
		@hibernate.collection-element column="`value`" type="double" not-null="true"
	*/
	public List<Double> getValues()
	{
		if (values == null)
		{
			values = new ArrayList<Double>();
		}
		return values;
	}
	void setValues(List<Double> values)
	{
		this.values = values;
	}

	public String toString()
	{
		return values.toString();
	}	
}
