/*
	$Id: LabeledExtractData.java 4517 2008-09-11 20:11:02Z jari $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

/**
	This represents a labeled extract.

	@author Nicklas
	@version 2.0
	@see net.sf.basedb.core.LabeledExtract
	@see <a href="../../../../../../html/developerdoc/api/data_api.biomaterials.html">Biomaterials overview</a>
	@base.modified $Date: 2008-09-11 22:11:02 +0200 (Thu, 11 Sep 2008) $
	@hibernate.subclass discriminator-value="4" lazy="false"
*/
public class LabeledExtractData
	extends MeasuredBioMaterialData
{

	public LabeledExtractData()
	{}
	
	private LabelData label;
	/**
		The label compound used to label the extract. This property is actually not-null="true", but
		since we are using a common table for all biomaterial and the other types doesn't have a label,
		it must be declared not-null="false". It is up to the core to check that no null values are
		passed to the database.
		@hibernate.many-to-one column="`label_id`" not-null="false" outer-join="false"
	*/
	public LabelData getLabel()
	{
		return label;
	}
	public void setLabel(LabelData label)
	{
		this.label = label;
	}
}
