/*
  $Id: SoftwareData.java 4696 2008-12-09 13:55:06Z nicklas $

	Copyright (C) 2005 Johan Enell, Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

  BASE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3
  of the License, or (at your option) any later version.

  BASE is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

import java.util.Date;

/**
	This class holds information about a software.
	
	@author enell
	@version 2.0
	@see net.sf.basedb.core.Software
	@see <a href="../../../../../../html/developerdoc/api/data_api.wares.html">Hardware and software overview</a>
	@base.modified $Date: 2008-12-09 14:55:06 +0100 (Tue, 09 Dec 2008) $
	@hibernate.class table="`Software`" lazy="true"
*/
public class SoftwareData
	extends CommonData
	implements RegisteredData
{
	public SoftwareData()
	{}
	/*
		From the RegisteredData interface
		-------------------------------------------
	*/
	private Date entryDate;
	public Date getEntryDate()
	{
		return entryDate;
	}
	public void setEntryDate(Date entryDate)
	{
		this.entryDate = entryDate;
	}
	// -------------------------------------------
	
	private SoftwareTypeData softwareType;
	
	public static final int MAX_VERSIONSTRING_LENGTH = 255;
	
	/**
		@hibernate.many-to-one column="`softwaretype_id`" not-null="true" outer-join="false"
	*/
	public SoftwareTypeData getSoftwareType()
	{
		return softwareType;
	}
	public void setSoftwareType(SoftwareTypeData softwareType)
	{
		this.softwareType = softwareType;
	}
	
	private String versionString;
	/**
		@hibernate.property column="`version_string`" type="string" length="255" not-null="false"
	*/
	public String getVersionString()
	{
		return versionString;
	}
	public void setVersionString(String versionString)
	{
		this.versionString = versionString;
	}
}
