<%-- $Id: edit_protocol.jsp 4510 2008-09-11 20:03:48Z jari $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.ProtocolType"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.FileType"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.PROTOCOL;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Protocol protocol = null;
	boolean readCurrentProtocolType = true;
	int currentProtocolTypeId = 0;
	boolean readCurrentFile = true;
	File currentFile = null;
	ItemQuery<AnnotationType> parameterQuery = null;

	// Load recently used items
	List<File> recentFiles = (List<File>)cc.getRecent(dc, Item.FILE);

	if (itemId == 0)
	{
		title = "Create protocol";

		currentProtocolTypeId = Values.getInt(request.getParameter("protocoltype_id"));
		if (currentProtocolTypeId == 0) 
		{
			int recentProtocolTypeId = Values.getInt(cc.getRecent(Item.PROTOCOLTYPE.name(), 0));
			currentProtocolTypeId = Values.getInt(cc.getPropertyValue("protocolType"), recentProtocolTypeId);
		}
		cc.removeObject("item");
	}
	else
	{
		protocol = Protocol.getById(dc, itemId);
		parameterQuery = protocol.getParameters();
		cc.setObject("item", protocol);
		title = "Edit protocol -- " + HTML.encodeTags(protocol.getName());
		try
		{
			ProtocolType pt = protocol.getProtocolType();
			if (pt != null) currentProtocolTypeId = pt.getId();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocolType = false;
		}
		try
		{
			currentFile = protocol.getFile();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentFile = false;
		}
	}
	if (protocol != null && !protocol.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	
	// Query to retrieve protocol types
	final ItemQuery<ProtocolType> protocolTypeQuery = ProtocolType.getQuery();
	protocolTypeQuery.include(Include.ALL);
	protocolTypeQuery.order(Orders.asc(Hql.property("name")));
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,linkitems.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Protocol" tab
		function validateProtocol()
		{
			var frm = document.forms['protocol'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}
		// Validate the "Parameters" tab
		function validateParameters()
		{
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['protocol'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.addedAnnotationTypes.value = Link.getActionIds(1, 'A').join(',');
				frm.removedAnnotationTypes.value = Link.getActionIds(-1, 'A').join(',');
				frm.submit();
			}
		}
		
		function browseOnClick()
		{
			var frm = document.forms['protocol'];
			var url = '../../filemanager/index.jsp?ID=<%=ID%>&cmd=SelectOne&title=Select+protocol&callback=setFileCallback';
			url += '&filter:INT:fileType=<%=SystemItems.getId(FileType.PROTOCOL)%>';
			if (frm.file_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.file_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectFile', 1000, 700);
		}
		function setFileCallback(id, path)
		{
			var frm = document.forms['protocol'];
			var list = frm.file_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = path;
			list.selectedIndex = 1;
		}

		function init()
		{
			var frm = document.forms['protocol'];
			<%
			if (protocol == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			if (parameterQuery != null)
			{
				%>
				var annotationTypes = frm.annotationTypes;
				<%
				parameterQuery.include(Include.ALL);
				parameterQuery.order(Orders.asc(Hql.property("name")));
				ItemResultList<AnnotationType> parameters = parameterQuery.list(dc);
				for (AnnotationType at : parameters)
				{
					%>
					Link.addNewItem(annotationTypes, new Item('A', <%=at.getId()%>, '<%=HTML.javaScriptEncode(at.getName())%>'));
					<%
				}
			}
			%>
		}
		function addAnnotationTypesOnClick()
		{
			var frm = document.forms['protocol'];
			var ids = Link.getListIds(frm.annotationTypes, 'A');
			var excludes = ids.join(',');
			var url = '../annotationtypes/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addAnnotationTypeCallback';
			url += '&filter:BOOLEAN:protocolParameter=true';
			url += "&exclude="+excludes;
			Main.openPopup(url, 'AddAnnotationTypes', 1000, 700);
		}
		function addAnnotationTypeCallback(annotationTypeId, name)
		{
			var item = Link.getItem('A', annotationTypeId);
			if (!item) item = new Item('A', annotationTypeId, name);
			Link.addItem(document.forms['protocol'].annotationTypes, item);
		}
		function removeAnnotationTypesOnClick()
		{
			Link.removeSelected(document.forms['protocol'].annotationTypes);
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="protocol" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*220)+"px;"%>" 
			position="bottom"  remember="<%=protocol != null%>">
		<t:tab id="info" title="Protocol" validate="validateProtocol()" helpid="protocol.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(protocol == null ? Values.getString(cc.getPropertyValue("name"), "New protocol") : protocol.getName())%>" 
					size="40" maxlength="<%=Protocol.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Type</td>
				<td colspan="2">
					<select name="protocoltype_id" 
						<%=!readCurrentProtocolType ? "disabled readonly class=\"disabled\"" : "class=\"required\""%>>
					<%
					if (!readCurrentProtocolType)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						for (ProtocolType protocolType : protocolTypeQuery.list(dc))
						{
							int id = protocolType.getId();
							if (id != currentProtocolTypeId && protocolType.isRemoved()) continue;
							%>
							<option value="<%=id == currentProtocolTypeId && protocol != null ? -id : id%>" 
								<%=id == currentProtocolTypeId ? "selected" : ""%>
								><%=HTML.encodeTags(protocolType.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
			</tr>
			<tr>
				<td class="prompt">File</td>
				<td>
					<base:select 
						id="file_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentFile%>"
						denied="<%=!readCurrentFile%>"
						recent="<%=recentFiles%>"
						newitem="<%=protocol == null%>"
						onselect="browseOnClick()"
					/>
				</td>
			</tr>

			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(protocol == null ? cc.getPropertyValue("description") : protocol.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'protocol', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		
		<t:tab id="parameters" title="Parameters" 
			validate="validateParameters()" helpid="protocol.edit.parameters">
		<table class="form" cellspacing=0>

		<tr valign="top">
			<td><b>Annotation types</b>
				<table border="0" cellspacing="0" cellpadding="0">
				<tr valign="top">
				<td>
					<select name="annotationTypes" size="10" multiple style="width: 20em;">
					</select>
					<input type="hidden" name="addedAnnotationTypes" value="">
					<input type="hidden" name="removedAnnotationTypes" value="">
				</td>
				<td>
					<table border="0">
					<tr><td width="150"><base:button 
						onclick="addAnnotationTypesOnClick()" 
						title="Add annotation types&hellip;" 
						tooltip="Add annotation types"
						/></td></tr>
					<tr><td width="150"><base:button 
						onclick="removeAnnotationTypesOnClick()" 
						title="Remove" 
						tooltip="Remove the selected annotation types"
					/></td></tr>
					</table>
				</td>
				</tr>
				</table>
			</td>
		</tr>
		</table>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
