<%-- $Id: view_quantity.jsp 4565 2008-10-07 07:58:00Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.Map"
	import="java.util.Set"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.QUANTITY;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	Quantity quantity = Quantity.getById(dc, itemId);
	
	final boolean usePermission = quantity.hasPermission(Permission.USE);
	final boolean writePermission = quantity.hasPermission(Permission.WRITE);
	final boolean deletePermission = quantity.hasPermission(Permission.DELETE);
	final boolean isRemoved = quantity.isRemoved();
	final boolean isUsed = isRemoved && quantity.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	%>

	<base:page title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="toolbar.css,headertabcontrol.css,path.css,table.css">
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		function newUnit()
		{
			Main.viewOrEditItem('<%=ID%>', 'UNIT', 0, true, '&quantity_id=<%=itemId%>');
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Quantities" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(quantity.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="properties">
		<t:tab id="properties" title="Properties">
		
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this quantity" : "You do not have permission to edit this quantity"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!quantity.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this quantity" : "You do not have permission to delete this quantity"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=quantity.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this quantity" : "You do not have permission to restore this quantity"%>" 
			/>
			<tbl:button
				image="add.png"
				onclick="newUnit()"
				title="New unit&hellip;"
				tooltip="Create a new unit for this quantity"
				visible="<%=sc.hasPermission(Permission.CREATE, Item.UNIT) && usePermission%>"
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'quantity.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(quantity)%></i></div>
			<%
			if (quantity.isRemoved())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Quantity</td>
				<td><%=HTML.encodeTags(quantity.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">System ID</td>
				<td><%=HTML.encodeTags(quantity.getSystemId())%></td>
			</tr>
			<tr>
				<td class="prompt">Reference unit</td>
				<td><%=HTML.encodeTags(quantity.getReferenceUnit())%></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(quantity.getDescription())%></td>
			</tr>
			</table>
			
			<%
			ItemQuery<Unit> unitQuery = quantity.getUnits();
			unitQuery.join(Hql.leftJoin(null, "symbols", "sym", null, true));
			unitQuery.include(Include.ALL);
			unitQuery.order(Orders.desc(Hql.property("referenceFactor")));
			unitQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<Unit> units = unitQuery.list(dc);
			if (units.size() == 0)
			{
				%>
				<h4>Units</h4>
				No units for this quantity exists
				(or, you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<h4 class="docked">Units</h4>
				<tbl:table
					id="units"
					clazz="itemlist"
					columns="all"
					>
				<tbl:columndef 
					id="name"
					title="Name"
				/>
				<tbl:columndef 
					id="symbols"
					title="Symbols"
				/>
				<tbl:columndef 
					id="formula"
					title="Conversion formula"
				/>
				<tbl:columndef 
					id="description"
					title="Description"
				/>
				<tbl:data>
					<tbl:columns>
					</tbl:columns>
					<tbl:rows>
					<%
					for (Unit item : units)
					{
						StringBuilder formula = new StringBuilder();
						formula.append("1&nbsp;").append(item.getDisplaySymbol()).append(" = ");
						if (item.getReferenceFactor() != 1.0)
						{
							formula.append(item.getReferenceFactor()).append("  ");
						}
						formula.append(quantity.getReferenceUnit());
						if (item.getReferenceOffset() != 0.0)
						{
							formula.append(" + ").append(item.getReferenceOffset());
						}
						Set<String> symbols = item.getSymbols();
						symbols.remove(item.getDisplaySymbol());
						symbols.add("<b>" + item.getDisplaySymbol() + "</b>");
						%>
						<tbl:row>
							<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=item.isRemoved()%>"
								/><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
							<tbl:cell column="symbols"><%=Values.getString(symbols, ", ", true) %></tbl:cell>
							<tbl:cell column="formula"><%=formula.toString()%></tbl:cell>
							<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
						</tbl:row>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
				</tbl:table>
				<%
			}
			%>

		</div>
		</t:tab>
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
