<%-- $Id: list_biowells.jsp 4781 2009-02-23 12:41:44Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Martin
	@version 2.10
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.BIOWELL;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final int bioplateId = Values.getInt(request.getParameter("bioplate_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("biowell", "biowells");
final DbControl dc = sc.newDbControl();
ItemResultIterator<BioWell> biowells = null;

Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);

try
{
	final BioPlate bioplate = BioPlate.getById(dc, bioplateId);
	final boolean createPermission = bioplate.hasPermission(Permission.WRITE);
	final boolean deletePermission = createPermission;

	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	
	try
	{
		final ItemQuery<BioWell> query = Base.getConfiguredQuery(dc, cc, true, bioplate.getBioWells(), mode);
		query.join(Hql.leftJoin(null, "bioMaterial", "mbm", null, false));
		if (!"row".equals(cc.getSortProperty())) query.order(Orders.asc(Hql.property("row")));
		if (!"column".equals(cc.getSortProperty())) query.order(Orders.asc(Hql.property("column")));
		biowells = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	int numListed = 0;
	%>
	<base:page title="<%=title%>" type="<%=mode.getPageType()%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,headertabcontrol.css,path.css">
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'biowells';

		function editItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, true);
		}
		function itemOnClick(itemId)
		{
			Table.itemOnClick(formId, null, itemId, '<%=mode.getName()%>', null, null, returnSelected);
		}
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function runPlugin(cmd)
		{
			Table.submitToPopup(formId, cmd, 540, 460);
		}
		function returnSelected()
		{
			Table.returnSelected(formId, <%=callback != null ? "window.opener."+callback : "null" %>);
			window.close();
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'properties' || tabId == 'annotations')
			{
				location.href = '../index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=bioplateId%>&tab='+tabId;
			}			
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		</script>
	</base:head>
	
	<base:body>
		<%
		if (!mode.isSelectionMode())
		{
			%>
			<p>
			<p:path>
				<p:pathelement title="Bioplates" href="<%="../index.jsp?ID="+ID%>" />
				<p:pathelement title="<%=HTML.encodeTags(bioplate.getName())%>" />
			</p:path>
			<%
		}
		%>

		<t:tabcontrol id="main" active="biowells" switch="switchTab" notabs="<%=mode.isSelectionMode()%>">
		<t:tab id="properties" title="Properties" />
		<t:tab id="annotations" title="Annotations" />				
		<t:tab id="biowells" title="Biowells">
		
		<%
		if (cc.getMessage() != null)
		{
			%>
			<div class="error"><%=cc.getMessage()%></div>
			<%
			cc.setMessage(null);
		}
		%>
		<tbl:table 
			id="biowells" 
			clazz="itemlist" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			title="<%=title%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="bioplate_id" 
				value="<%=String.valueOf(bioplateId)%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="row"
				property="row"
				datatype="int"
				title="Row"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="column"
				property="column"
				datatype="int"
				title="Column"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>	
			<tbl:columndef 
				id="bioMaterial.name"
				property="bioMaterial.name"
				datatype="string"
				title="[Biomtrl] Name"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="bioMaterial.description"
				property="bioMaterial.description"
				datatype="string"
				title="[Biomtrl] Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef 
				id="bioMaterial.entryDate"
				property="bioMaterial.entryDate"
				datatype="date"
				title="[Biomtrl] Registered"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<tbl:columndef
				id="bioMaterialList"
				property="@bioMaterial.bioMaterialLists"
				datatype="int"
				title="[Biomtrl] Biomaterial list"
				filterable="true"
				enumeration="<%=Base.getBioMaterialListsEnum(dc, null, Include.ALL)%>"
				multiple="false"
			/>
			<tbl:columndef
				id="permission"
				title="Permission"
			/>
			<tbl:toolbar
				visible="<%=mode.hasToolbar()%>"
				>
				<tbl:button 
					image="columns.gif" 
					onclick="configureColumns()" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order columns" 
				/>
				<tbl:button 
					image="import.gif" 
					onclick="runPlugin('ImportItems')" 
					title="Import&hellip;" 
					tooltip="Import data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
				/>
				<tbl:button 
					image="export.gif" 
					onclick="runPlugin('ExportItems')" 
					title="Export&hellip;" 
					tooltip="Export data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
				/>
				<tbl:button 
					image="runplugin.gif" 
					onclick="runPlugin('RunListPlugin')" 
					title="Run plugin&hellip;" 
					tooltip="Run a plugin" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
				/>
			</tbl:toolbar>
			<tbl:navigator
				page="<%=cc.getPage()%>" 
				rowsperpage="<%=cc.getRowsPerPage()%>" 
				totalrows="<%=biowells == null ? 0 : biowells.getTotalCount()%>" 
				visible="<%=mode.hasNavigator()%>"
			/>
			<tbl:data>
				<tbl:columns>
				<tbl:presetselector 
					clazz="columnheader"
					colspan="3"
					onchange="presetOnChange()"
				/>
				</tbl:columns>
					
				<tr>
					<tbl:header 
						clazz="index"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasCheck()%>"
						><base:icon 
							image="check_uncheck.gif" 
							tooltip="Check/uncheck all" 
							onclick="Forms.checkUncheck(document.forms[formId])" style="align: left;"
						/></tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasRadio()%>"
						/>
					<tbl:header 
						clazz="icons" 
						visible="<%=mode.hasIcons()%>"
						>&nbsp;</tbl:header>
					<tbl:propertyfilter />
				</tr>
		
					<tbl:rows>
					<%
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (biowells != null)
					{						
						while (biowells.hasNext())
						{
							BioWell item = biowells.next();
							int itemId = item.getId();
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="<%=itemId%>" 
										value="<%=itemId%>" 
										title="[<%=item.getRow()%>,<%=item.getColumn()%>]" 
										<%=cc.getSelected().contains(itemId) ? "checked" : ""%> 
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
										type="radio" 
										name="item_id" 
										value="<%=itemId%>" 
										title="[<%=item.getRow()%>,<%=item.getColumn()%>]" 
										<%=selectedItemId == itemId ? "checked" : ""%>
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									>&nbsp;</tbl:header>
								
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="row">
									<%
									if (mode.isSelectionMode())
									{
										%>
										<div class="link" onclick="itemOnClick(<%=itemId%>)" title="Select this item">
											<%=item.getRow()%>
										</div>
									<%
									}
									else%><%=item.getRow()%>
								</tbl:cell>
								<tbl:cell column="column"><%=item.getColumn()%></tbl:cell>
								<tbl:cell column="bioMaterial.name">									
								<%
								MeasuredBioMaterial bioMaterial = null;
								boolean bmWritePermission = true;
								try
								{
									bioMaterial = item.getBioMaterial();
									if (bioMaterial != null)
									{
										bmWritePermission = bioMaterial.hasPermission(Permission.WRITE);										
									}
								}
								catch (PermissionDeniedException ex)
								{
									bmWritePermission = false;
								}
								%>
									<base:propertyvalue 
											item="<%=item%>" 
											property="bioMaterial"
											enableEditLink="<%=mode.hasEditLink() && bmWritePermission%>" 
											enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/>
									<base:icon 
										image="<%=bmWritePermission ? "edit.gif" : "edit_disabled.gif" %>" 
										tooltip="<%=bmWritePermission ? "Change the biomaterial in this biowell" : 
											"You have not permission to change the current biomaterial"%>"
										onclick="<%=bmWritePermission ? "editItem("+item.getId()+")" : ""%>"
									/>								
								</tbl:cell>
								<tbl:cell column="permission"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
							</tbl:row>
							<%
						}
					}
					%>
					</tbl:rows>
				</tbl:data>
			<%
			if (numListed == 0)
			{
				%>
				<tbl:panel><%=biowells == null || biowells.getTotalCount() == 0 ? "No biowells were found" : "No biowells on this page. Please select another page!" %></tbl:panel>
				<%
			}
			else
			{
				%>
				<tbl:navigator
					page="<%=cc.getPage()%>" 
					rowsperpage="<%=cc.getRowsPerPage()%>" 
					totalrows="<%=biowells == null ? 0 : biowells.getTotalCount()%>" 
					visible="<%=mode.hasNavigator()%>"
					locked="true"
				/>
				<%
			}
			%>
		</tbl:table>
		<base:buttongroup align="center" clazz="fixedatbottom">
			<base:button onclick="returnSelected();" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button onclick="window.close();" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button onclick="window.close();" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>
	
		</t:tab>
		</t:tabcontrol>

	
	</base:body>
	</base:page>
	<%
}
finally
{
	if (biowells != null) biowells.close();
	if (dc != null) dc.close();
}
%>