<%-- $Id: list_rawdata.jsp 4746 2009-02-10 11:51:56Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataProperty"
	import="net.sf.basedb.core.ReporterType"
	import="net.sf.basedb.core.Feature"
	import="net.sf.basedb.core.Reporter"
	import="net.sf.basedb.core.ArrayDesignBlock"
	import="net.sf.basedb.core.Well"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.DataQuery"
	import="net.sf.basedb.core.DataResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.data.RawData"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.core.data.FeatureData"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.RAWDATA;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final int rawBioAssayId = Values.getInt(request.getParameter("rawbioassay_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("raw data", "raw data");
final DbControl dc = sc.newDbControl();
DataResultIterator<RawData> rawData = null;
try
{
	RawBioAssay rawBioAssay = RawBioAssay.getById(dc, rawBioAssayId);
	RawDataType rawDataType = rawBioAssay.getRawDataType();
	final String subContext = rawDataType.getId();

	final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, null, null);

	final DataQuery<RawData> query = rawBioAssay.getRawData();
	query.join(Hql.leftJoin(null, "reporter", "r", null, true));
	query.join(Hql.leftJoin(null, "feature", "f", null, true));
	query.join(Hql.leftJoin("f", "arrayDesignBlock", "b", null, true));
	cc.configureQuery(dc, query, true);
	if (!"row".equals(cc.getSortProperty())) query.order(Orders.asc(Hql.property("row")));
	if (!"column".equals(cc.getSortProperty())) query.order(Orders.asc(Hql.property("column")));

	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	final ItemQuery<ReporterType> typeQuery = ReporterType.getQuery();
	typeQuery.order(Orders.asc(Hql.property("name")));
	typeQuery.setCacheResult(true);
	List<ExtendedProperty> reporterProperties = ExtendedProperties.getProperties("ReporterData");
	
	try
	{
		rawData = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
	}
	int numListed = 0;
	final boolean writeReporterPermission = sc.hasPermission(Permission.WRITE, Item.REPORTER);
	Formatter<Date> dateFormatter = FormatterFactory.getDateTimeFormatter(sc);
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,headertabcontrol.css,path.css">
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'rawdata';
		function viewItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, false, '&rawbioassay_id=<%=rawBioAssayId%>');
//			Main.openPopup('index.jsp?ID=<%=ID%>&rawbioassay_id=<%=rawBioAssayId%>&cmd=ViewItem&item_id='+itemId, 'ViewRawData', 700, 500);
		}
		function itemOnClick(evt, itemId)
		{
			viewItem(itemId);
		}
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function runPlugin(cmd)
		{
			Table.submitToPopup(formId, cmd, 700, 500);
		}
		function returnSelected()
		{
			Table.returnSelected(formId, <%=callback != null ? "window.opener."+callback : "null" %>);
			window.close();
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'properties' || tabId == 'annotations' || tabId == 'overview')
			{
				location.href = '../index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=rawBioAssayId%>&tab='+tabId;
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		function newReporterList()
		{
			Table.submitToPopup(formId, 'CreateReporterList', 540, 400);
		}
		</script>
	</base:head>
	
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Raw bioassays" href="<%="../index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(rawBioAssay.getName())%>" />
		</p:path>
		
		
		<t:tabcontrol id="main" active="rawdata" switch="switchTab">
		<t:tab id="properties" title="Properties" />
		<t:tab id="annotations" title="Annotations &amp; parameters" 
			tooltip="View annotation values and protocol parameters" />
		
		<t:tab id="rawdata" title="Raw data">

		<%
		if (cc.getMessage() != null)
		{
			%>
			<div class="error"><%=cc.getMessage()%></div>
			<%
			cc.setMessage(null);
		}
		%>
		<tbl:table 
			id="rawdata" 
			clazz="itemlist" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			title="<%=title%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subContext%>"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="rawbioassay_id" 
				value="<%=String.valueOf(rawBioAssayId)%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="position"
				clazz="uniquecol"
				property="position"
				datatype="int"
				title="[Raw] Position"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="block"
				property="block"
				datatype="int"
				title="[Raw] Block"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="metaGridX"
				property="metaGridX"
				datatype="int"
				title="[Raw] Meta grid X"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="metaGridY"
				property="metaGridY"
				datatype="int"
				title="[Raw] Meta grid Y"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="row"
				property="row"
				datatype="int"
				title="[Raw] Row"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="column"
				property="column"
				datatype="int"
				title="[Raw] Column"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="x"
				property="x"
				datatype="int"
				title="[Raw] X"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="y"
				property="y"
				datatype="int"
				title="[Raw] Y"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="spotImage"
				title="Spot image"
			/>
			<%
			for (RawDataProperty rdp : rawBioAssay.getRawDataType().getProperties())
			{
				%>
				<tbl:columndef
					id="<%="raw."+rdp.getName()%>"
					property="<%=rdp.getName()%>"
					datatype="<%=rdp.getType().getStringValue()%>"
					title="<%="[Raw] "+HTML.encodeTags(rdp.getTitle())%>"
					sortable="true" 
					filterable="true"
					exportable="true"
					formatter="<%=FormatterFactory.getExtendedPropertyFormatter(sc, rdp)%>"
				/>
				<%
			}
			%>
			<tbl:columndef
				id="reporterList"
				property="$r.reporterListScores"
				datatype="int"
				title="[Rep] Reporter list"
				filterable="true"
				enumeration="<%=Base.getReporterListsEnum(dc)%>"
				multiple="false"
			/>			
			<tbl:columndef 
				id="reporter.name"
				property="reporter.name"
				datatype="string"
				title="[Rep] Name"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="reporter.externalId"
				clazz="uniquecol"
				property="reporter.externalId"
				datatype="string"
				title="[Rep] ID"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="reporter.symbol"
				property="reporter.symbol"
				datatype="string"
				title="[Rep] Gene symbol"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="reporter.description"
				property="reporter.description"
				datatype="string"
				title="[Rep] Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef 
				id="reporter.lastUpdate"
				property="reporter.lastUpdate"
				datatype="date"
				title="[Rep] Last update" 
				sortable="true" 
				filterable="true" 
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<%
			Enumeration<String, String> types = new Enumeration<String, String>();
			ItemResultList<ReporterType> reporterTypes = typeQuery.list(dc);
			types.add("", "- none -");
			for (ReporterType rt : reporterTypes)
			{
				types.add(Integer.toString(rt.getId()), HTML.encodeTags(rt.getName()));
			}
			%>
			<tbl:columndef 
				id="reporter.reporterType"
				property="reporter.reporterType"
				sortproperty="reporter.reporterType.name"
				exportproperty="reporter.reporterType.name"
				datatype="int"
				enumeration="<%=types%>"
				title="[Rep] Type"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<%
			if (reporterProperties != null)
			{
				for (ExtendedProperty ep : reporterProperties)
				{
					String name = ep.getName();
					%>
					<tbl:columndef
						id="<%="reporter."+name%>"
						property="<%="reporter."+name%>"
						datatype="<%=ep.getType().getStringValue()%>"
						title="<%="[Rep] "+HTML.encodeTags(ep.getTitle())%>"
						sortable="true"
						filterable="true"
						exportable="true"
						formatter="<%=FormatterFactory.getExtendedPropertyFormatter(sc, ep)%>"
					/>
					<%
				}
			}
			%>
			<tbl:columndef 
				id="feature.position"
				clazz="uniquecol"
				property="feature.position"
				datatype="int"
				title="[Feat] Position" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef 
				id="feature.externalId"
				clazz="uniquecol"
				property="feature.externalId"
				datatype="string"
				title="[Feat] Feature ID" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef 
				id="feature.block"
				property="feature.block"
				datatype="int"
				title="[Feat] Block"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="feature.metaGridX"
				property="feature.arrayDesignBlock.metaGridX"
				datatype="int"
				title="[Feat] Meta grid X"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="feature.metaGridY"
				property="feature.arrayDesignBlock.metaGridY"
				datatype="int"
				title="[Feat] Meta grid Y"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="feature.row"
				property="feature.row"
				datatype="int"
				title="[Feat] Row"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="feature.column"
				property="feature.column"
				datatype="int"
				title="[Feat] Column"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="feature.blockSizeX"
				property="feature.arrayDesignBlock.blockSizeX"
				datatype="int"
				title="[Feat] Block size X"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="feature.blockSizeY"
				property="feature.arrayDesignBlock.blockSizeY"
				datatype="int"
				title="[Feat] Block size Y"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="feature.originX"
				property="feature.arrayDesignBlock.originX"
				datatype="int"
				title="[Feat] Origin X"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="feature.originY"
				property="feature.arrayDesignBlock.originY"
				datatype="int"
				title="[Feat] Origin Y"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="feature.spacingX"
				property="feature.arrayDesignBlock.spacingX"
				datatype="int"
				title="[Feat] Spacing X"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="feature.spacingY"
				property="feature.arrayDesignBlock.spacingY"
				datatype="int"
				title="[Feat] Spacing Y"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="well.row"
				property="feature.well.row"
				datatype="int"
				title="[Well] Row" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef 
				id="well.column"
				property="feature.well.column"
				datatype="int"
				title="[Well] Column" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef 
				id="well.plate"
				property="feature.well.plate.name"
				datatype="string"
				title="[Well] Plate" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:toolbar
				visible="<%=mode.hasToolbar()%>"
				>
				<tbl:button 
					image="columns.gif" 
					onclick="configureColumns()" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order columns" 
				/>
				<tbl:button
					image="add.png"
					onclick="newReporterList()"
					title="New reporter list&hellip;"
					tooltip="Create a new reporter list from matching spots"
					visible="<%=sc.hasPermission(Permission.CREATE, Item.REPORTERLIST)%>"
				/>
				<tbl:button 
					image="import.gif" 
					onclick="runPlugin('ImportItems')" 
					title="Import&hellip;" 
					tooltip="Import data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
				/>
				<tbl:button 
					image="export.gif" 
					onclick="runPlugin('ExportItems')" 
					title="Export&hellip;" 
					tooltip="Export data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
				/>
				<tbl:button 
					image="runplugin.gif" 
					onclick="runPlugin('RunListPlugin')" 
					title="Run plugin&hellip;" 
					tooltip="Run a plugin" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
				/>
			</tbl:toolbar>
			<tbl:navigator
				page="<%=cc.getPage()%>" 
				rowsperpage="<%=cc.getRowsPerPage()%>" 
				totalrows="<%=rawData == null ? 0 : rawData.getTotalCount()%>" 
				visible="<%=mode.hasNavigator()%>"
			/>
			<tbl:data>
				<tbl:columns>
				<tbl:presetselector 
					clazz="columnheader"
					colspan="3"
					onchange="presetOnChange()"
				/>
				</tbl:columns>
					
				<tr>
					<tbl:header 
						clazz="index"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasCheck()%>"
						><base:icon 
							image="check_uncheck.gif" 
							tooltip="Check/uncheck all" 
							onclick="Forms.checkUncheck(document.forms[formId])" style="align: left;"
						/></tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasRadio()%>"
						/>
					<tbl:header 
						clazz="icons" 
						visible="<%=mode.hasIcons()%>"
						>&nbsp;</tbl:header>
					<tbl:propertyfilter />
				</tr>
		
					<tbl:rows>
					<%
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					boolean hasSpotImages = rawBioAssay.hasSpotImages();
					if (rawData != null)
					{
						String tooltip = mode.isSelectionMode() ?
							"Select this item" : "View this item";
						while (rawData.hasNext())
						{
							RawData item = rawData.next();
							int itemId = item.getId();
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
											type="checkbox" 
											name="<%=itemId%>" 
											value="<%=itemId%>" 
											title="TODO" 
											<%=request.getParameter(Integer.toString(itemId)) == null ? "" : "checked"%> 
										></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
											type="radio" 
											name="item_id" 
											value="<%=itemId%>" 
											title="TODO" 
											<%=selectedItemId == itemId ? "checked" : ""%>
										></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									></tbl:header>
								<tbl:cell column="position"><div class="link" onclick="itemOnClick(event, <%=itemId%>)" 
									title="<%=tooltip%>"><%=item.getPosition()%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="block"><%=item.getBlock()%></tbl:cell>
								<tbl:cell column="row"><%=item.getRow()%></tbl:cell>
								<tbl:cell column="column"><%=item.getColumn()%></tbl:cell>
								<tbl:cell column="metaGridX"><%=item.getMetaGridX()%></tbl:cell>
								<tbl:cell column="metaGridY"><%=item.getMetaGridY()%></tbl:cell>
								<tbl:cell column="x"><%=item.getX()%></tbl:cell>
								<tbl:cell column="y"><%=item.getY()%></tbl:cell>
								<tbl:cell column="spotImage">
									<%
									if (hasSpotImages)
									{
										%>
										<img src="spotimage/<%=ID%>/<%=rawBioAssay.getId()%>/<%=itemId%>/spot<%=item.getPosition()%>.png">
										<%
									}
									%>
								</tbl:cell>
								<%
								for (RawDataProperty rdp : rawBioAssay.getRawDataType().getProperties())
								{
									%>
									<tbl:cell column="<%="raw."+rdp.getName()%>"><tbl:cellvalue value="<%=item.getExtended(rdp.getName())%>" /></tbl:cell>
									<%
								}
								%>
								<%
								ReporterData reporter = item.getReporter();
								if (reporter == null)
								{
									%>
									<tbl:cell column="reporter.name"><i>- none -</i></tbl:cell>
									<tbl:cell column="reporter.externalId"><i>- none -</i></tbl:cell>
									<%
								}
								else
								{
									%>
									<tbl:cell column="reporter.name"><%=Base.getLink(ID, reporter.getName(), Item.REPORTER, reporter.getId(), writeReporterPermission)%></tbl:cell>
									<tbl:cell column="reporter.externalId"><%=HTML.encodeTags(reporter.getExternalId())%></tbl:cell>
									<tbl:cell column="reporter.symbol"><%=HTML.encodeTags(reporter.getSymbol())%></tbl:cell>
									<tbl:cell column="reporter.description"><%=HTML.encodeTags(reporter.getDescription())%></tbl:cell>
									<tbl:cell column="reporter.lastUpdate" value="<%=reporter.getLastUpdate()%>" />
									<tbl:cell column="reporter.reporterType"><base:propertyvalue dbcontrol="<%=dc%>" item="<%=reporter%>" property="reporterType.name" /></tbl:cell>
									<%
									if (reporterProperties != null)
									{
										for (ExtendedProperty ep : reporterProperties)
										{
											String name = ep.getName();
											%>
											<tbl:cell column="<%="reporter."+name%>"><tbl:cellvalue value="<%=reporter.getExtended(name)%>" /></tbl:cell>
											<%
										}
									}
								}
								%>
								<%
								FeatureData feature = item.getFeature();
								if (feature == null)
								{
									%>
									<tbl:cell column="feature.position"><i>- none -</i></tbl:cell>
									<tbl:cell column="feature.externalId"><i>- none -</i></tbl:cell>
									<tbl:cell column="feature.row"><i>- none -</i></tbl:cell>
									<tbl:cell column="feature.column"><i>- none -</i></tbl:cell>
									<tbl:cell column="feature.block"><i>- none -</i></tbl:cell>
									<tbl:cell column="feature.metaGridX"><i>- none -</i></tbl:cell>
									<tbl:cell column="feature.metaGridY"><i>- none -</i></tbl:cell>
									<tbl:cell column="feature.blockSizeX"><i>- none -</i></tbl:cell>
									<tbl:cell column="feature.blockSizeY"><i>- none -</i></tbl:cell>
									<tbl:cell column="feature.originX"><i>- none -</i></tbl:cell>
									<tbl:cell column="feature.originY"><i>- none -</i></tbl:cell>
									<tbl:cell column="feature.spacingX"><i>- none -</i></tbl:cell>
									<tbl:cell column="feature.spacingY"><i>- none -</i></tbl:cell>
									<%
								}
								else
								{
									%>
									<tbl:cell column="feature.position"><%=feature.getPosition()%></tbl:cell>
									<tbl:cell column="feature.externalId"><%=HTML.encodeTags(feature.getExternalId())%></tbl:cell>
									<tbl:cell column="feature.row"><%=feature.getRow()%></tbl:cell>
									<tbl:cell column="feature.column"><%=feature.getColumn()%></tbl:cell>
									<%
									ArrayDesignBlock block = null;
									try
									{
										block = Feature.getArrayDesignBlock(dc, feature);
									}
									catch (PermissionDeniedException ex)
									{}
									if (block == null)
									{
										%>
										<tbl:cell column="feature.block"><i>- denied -</i></tbl:cell>
										<tbl:cell column="feature.metaGridX"><i>- denied -</i></tbl:cell>
										<tbl:cell column="feature.metaGridY"><i>- denied -</i></tbl:cell>
										<tbl:cell column="feature.blockSizeX"><i>- denied -</i></tbl:cell>
										<tbl:cell column="feature.blockSizeY"><i>- denied -</i></tbl:cell>
										<tbl:cell column="feature.originX"><i>- denied -</i></tbl:cell>
										<tbl:cell column="feature.originY"><i>- denied -</i></tbl:cell>
										<tbl:cell column="feature.spacingX"><i>- denied -</i></tbl:cell>
										<tbl:cell column="feature.spacingY"><i>- denied -</i></tbl:cell>
										<%
									}
									else
									{
										%>
										<tbl:cell column="feature.block"><%=block.getBlockNumber()%></tbl:cell>
										<tbl:cell column="feature.metaGridX"><%=block.getMetaGridX()%></tbl:cell>
										<tbl:cell column="feature.metaGridY"><%=block.getMetaGridY()%></tbl:cell>
										<tbl:cell column="feature.blockSizeX"><%=block.getBlockSizeX()%></tbl:cell>
										<tbl:cell column="feature.blockSizeY"><%=block.getBlockSizeY()%></tbl:cell>
										<tbl:cell column="feature.originX"><%=block.getOriginX()%></tbl:cell>
										<tbl:cell column="feature.originY"><%=block.getOriginY()%></tbl:cell>
										<tbl:cell column="feature.spacingX"><%=block.getSpacingX()%></tbl:cell>
										<tbl:cell column="feature.spacingY"><%=block.getSpacingY()%></tbl:cell>
										<%
									}
									Well well = null;
									boolean readWell = true;
									try
									{
										well = Feature.getWell(dc, feature);
									}
									catch (PermissionDeniedException ex)
									{
										readWell = false;
									}
									if (!readWell)
									{
										%>
										<tbl:cell column="well.row"><i>- denied -</i></tbl:cell>
										<tbl:cell column="well.column"><i>- denied -</i></tbl:cell>
										<tbl:cell column="well.plate"><i>- denied -</i></tbl:cell>
										<%
									}
									else if (well == null)
									{
										%>
										<tbl:cell column="well.row"><i>- none -</i></tbl:cell>
										<tbl:cell column="well.column"><i>- none -</i></tbl:cell>
										<tbl:cell column="well.plate"><i>- none -</i></tbl:cell>
										<%
									}
									else
									{
										%>
										<tbl:cell column="well.row"><%=well.getRow()%></tbl:cell>
										<tbl:cell column="well.column"><%=well.getColumn()%></tbl:cell>
										<tbl:cell column="well.plate"><%=well.getPlate().getName()%></tbl:cell>
										<%
									}
								}
								%>
							</tbl:row>
							<%
						}
					}
					%>
					</tbl:rows>
				</tbl:data>
			<%
			if (numListed == 0)
			{
				%>
				<tbl:panel><%=rawData == null || rawData.getTotalCount() == 0 ? "No raw data were found" : "No raw data on this page. Please select another page!" %></tbl:panel>
				<%
			}
			else
			{
				%>
				<tbl:navigator
					page="<%=cc.getPage()%>" 
					rowsperpage="<%=cc.getRowsPerPage()%>" 
					totalrows="<%=rawData == null ? 0 : rawData.getTotalCount()%>" 
					visible="<%=mode.hasNavigator()%>"
					locked="true"
				/>
				<%
			}
			%>
		</tbl:table>
		<base:buttongroup align="center">
			<base:button onclick="returnSelected();" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button onclick="window.close();" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button onclick="window.close();" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>
		
		</t:tab>
		<t:tab id="overview" title="Overview" 
			tooltip="Display a tree overview of related items" />
		</t:tabcontrol>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (rawData != null) rawData.close();
	if (dc != null) dc.close();
}
%>
